import React from 'react';
import { Navigate } from 'react-router-dom';

type ProtectedRouteProps = {
  isAllowed: boolean;
  children: React.ReactNode;
};

export const ProtectedRoute = ({ isAllowed, children }: ProtectedRouteProps) => {
  if (!isAllowed) {
    return <Navigate to="/auth" replace />;
  }

  return children;
};
