import { Module } from '@nestjs/common';
import { APP_GUARD } from '@nestjs/core';
import { TypeOrmModule } from '@nestjs/typeorm';
import { AuthModule } from './auth/auth.module';
import { CategoryModule } from './category/category.module';
import { Category } from './category/entities/category.entity';
import { RolesGuard } from './common/guards/roles.guard';
import { Product } from './product/entities/product.entity';
import { ProductModule } from './product/product.module';
import { SeedModule } from './seed/seed.module';
import { User } from './user/entities/user.entity';
import { UserModule } from './user/user.module';
@Module({
  imports: [
    TypeOrmModule.forRoot({
      type: 'postgres',
      host: 'localhost',
      port: 5432,
      username: 'postgres',
      password: 'root',
      database: 'postgres',
      schema: 'public',
      entities: [Product, Category, User],
      synchronize: true,
      logging: true,
      autoLoadEntities: true,
    }),
    ProductModule,
    CategoryModule,
    UserModule,
    AuthModule,
    SeedModule,
  ],
  controllers: [],
  providers: [
    {
      provide: APP_GUARD,
      useClass: RolesGuard,
    },
  ],
})
export class AppModule {}
